local A1, A2 = 727595, 798405  -- 5^17=D20*A1+A2
local D20, D40 = 1048576, 1099511627776  -- 2^20, 2^40
local X1, X2 = 0, 1
function rand()
    local U = X2*A2
    local V = (X1*A2 + X2*A1) % D20
    V = (V*D20 + U) % D40
    X1 = math.floor(V/D20)
    X2 = V - X1*D20
    return V/D40
end
function RandBetween(a, b)
	local r = rand()
	local d = b-a
	local e = d*r
	return a + e
end

function init(self)
	self.Timer = GetTime()
	self.Flags.AlwaysActive = true
end

function isClawInRange(self)
	claw = GetClaw()
	if self.XMin <= claw.X and self.YMin <= claw.Y and self.XMax >= claw.X and self.YMax >= claw.Y then
		return true
	else
		return false
	end
end

function main(self)
	if self.Timer == nil then
		self.Timer = GetTime()
	end
	--TextOut(self.State)
	if self.State == 0 then -- reload phase
  		if GetTime() >= self.Timer+500 == true then
			self.State = 1
			self.Magazine = 4
			self.Timer = GetTime()
			
		end
	elseif self.State == 1 then -- attack phase
		if GetTime() >= self.Timer+1000 then
			--TextOut("Shot")
			
			if isClawInRange(self) then
				PlaySound("CUSTOM_BARRAGE2")
				if nRes(6) > 30 then
					self.spdX = self.SpeedX*160/nRes(6)
					self.spdY = self.SpeedY*160/nRes(6)
				else
					self.spdX = self.SpeedX*4
					self.spdY = self.SpeedY*4
				end
				CreateObject {x=RandBetween(self.X-128, self.X-64), y=RandBetween(self.Y-128, self.Y), z=1914, name="ArtilleryShell", logic="CustomLogic", image="LEVEL_CANNONBALL", SpeedX = self.spdX, SpeedY = self.spdY}
				CreateObject {x=RandBetween(self.X-64, self.X), y=RandBetween(self.Y-128, self.Y), z=1914, name="ArtilleryShell", logic="CustomLogic", image="LEVEL_CANNONBALL", SpeedX = self.spdX, SpeedY = self.spdY}
				CreateObject {x=RandBetween(self.X, self.X+64), y=RandBetween(self.Y-128, self.Y), z=1914, name="ArtilleryShell", logic="CustomLogic", image="LEVEL_CANNONBALL", SpeedX = self.spdX, SpeedY = self.spdY}
				CreateObject {x=RandBetween(self.X+64, self.X+128), y=RandBetween(self.Y-128, self.Y), z=1914, name="ArtilleryShell", logic="CustomLogic", image="LEVEL_CANNONBALL", SpeedX = self.spdX, SpeedY = self.spdY}
			end
			
			self.Magazine = self.Magazine - 1
			self.Timer = GetTime()
		end
		
		if self.Magazine <= 0 then
			self.State = 2
		end
	elseif self.State == 2 then -- reload phase
		if GetTime() >= self.Timer+2000 then
			self.State = 0
			self.Magazine = 4
			self.Timer = GetTime()
		end
	end
end
















